#include <string.h>
#include "quicksort.h"
#include "../inout/test_inout.h"

static int
input_hooks(test_input_hooks_t** hooks) {
  hooks[0] = &test_input_string_modlist;
  return 1;
}

static int
output_hooks(test_output_hooks_t** hooks) {
  hooks[0] = &test_output_string_modlist;
  return 1;
}

static int isgt (char* x, char* y) {
  return strcmp(x, y) > 0;
}

static void
run(modref_t** inputs,
    modref_t** outputs) {
  modref_t* _TEMP = modref();
  scope();
  quicksort(inputs[0], isgt, outputs[0]);
}

static test_app_hooks_t hooks = {
  input_hooks,
  output_hooks,
  test_input_sizes_for_1_input,
  run,
  verif(run),
};

test_app_t test_app_quicksort = {"quicksort", &hooks};
